"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ts_custom_error_1 = require("ts-custom-error");
var JsonApiError = /** @class */ (function (_super) {
    __extends(JsonApiError, _super);
    function JsonApiError(input) {
        var _this = this;
        var opts = {};
        var inputType = typeof input;
        switch (inputType) {
            case 'string':
                opts.detail = input;
                break;
            case 'object':
                opts = Object.keys(input).reduce(function (acc, k) {
                    if (k && input[k] && JsonApiError.allowedProps.includes(k)) {
                        acc[k] = input[k];
                    }
                    return acc;
                }, {});
                break;
            default:
                throw new TypeError("Could not parse " + input + " as JsonApiError options");
        }
        Object.keys(opts)
            .forEach(function (k) {
            _this.constructor[k] = opts[k];
        });
        _this = _super.call(this, opts.detail) || this;
        return _this;
    }
    JsonApiError.prototype.toJSON = function () {
        var _this = this;
        return JsonApiError.allowedProps.reduce(function (error, propName) {
            if (_this.constructor[propName]) {
                error[propName] = _this.constructor[propName];
            }
            return error;
        }, {});
    };
    JsonApiError.allowedProps = ['id', 'link', 'status', 'code', 'title', 'detail', 'source', 'meta'];
    return JsonApiError;
}(ts_custom_error_1.CustomError));
exports.default = JsonApiError;
